# Figure 1 ----


# back upFigure 1D. Visualization of dendrites ----
if(0) {
  dir_vis <- "/home/admin/Documents/YanLab/Task_Local/LocalMorphology/visualization_clusters2/"
  
  
  index_neuron_AId_PT <- 
    base::intersect(Index_apical_tmp, 
                    base::intersect(which(dendrite_info$Type %in% c("ITi", "ITc", "PT", "CT")), 
                                    which(dendrite_info$BrainRegion == "PL")))[41:80]
  
  filename_apical <- 
    paste0(dir_vis, dendrite_info$SampleID[index_neuron_AId_PT], "-",
           stringr::str_pad(dendrite_info$NeuronID[index_neuron_AId_PT], 3, "left", "0"),
           "_apical_transformed.swc")
  
  filename_basal <- 
    paste0(dir_vis, dendrite_info$SampleID[index_neuron_AId_PT], "-",
           stringr::str_pad(dendrite_info$NeuronID[index_neuron_AId_PT], 3, "left", "0"),
           "_basal_transformed.swc")
  
  
  plot_dendrite_2D(filename_apical = filename_apical, 
                   filename_basal = filename_basal, 
                   color = ColorSourceRegion[4], 
                   name = paste0(dendrite_info$SampleID[index_neuron_AId_PT], 
                                 "-", 
                                 dendrite_info$NeuronID[index_neuron_AId_PT],
                                 "-",
                                 dendrite_info$Type[index_neuron_AId_PT]))
  
  
  
  
  plot_dendrite_2D(filename_apical = paste0(dir_vis, "195045-070_apical_transformed.swc"), 
                   filename_basal = paste0(dir_vis, "195045-070_basal_transformed.swc"), 
                   color = ColorSourceRegion[4], 
                   name = paste0("195045-070"))
  
  
  plot_dendrite_2D(filename_apical = paste0(dir_vis, "195044-012_apical_transformed.swc"), 
                   filename_basal = paste0(dir_vis, "195044-012_basal_transformed.swc"), 
                   color = ColorSourceRegion[4], 
                   name = paste0("195044-012"))
}


# Figure 1D. Dendritic length among axon classes and PFC subregions ----

df <- 
  data.frame(Group = factor(x = tmpMatch_axon[match(dendrite_info$Type[Index_apical_tmp], 
                                                    names(tmpMatch_axon))],
                            levels = c("IT", "PT", "CT")),
             Region = factor(x = dendrite_info$BrainRegion[Index_apical_tmp],
                             levels = SourceRegion[order(vector_mean[,2], decreasing = T)]),
             Value = feature_combine$dendrite_Volume)


ggplot(data = df, mapping = aes(x = Region, y = Value, group = Region, fill = Region)) +
  geom_boxplot() +
  facet_wrap(facets = "Group", nrow = 1, ncol = 3) +
  scale_fill_manual(values = ColorSourceRegion) +
  theme_classic2() +
  theme(axis.text.x = element_text(angle = 45, hjust = 1), 
        axis.line.y.left = element_line(size = 0.5))


# Figure 1D statistics ----
vector_mean <- matrix(nrow = 11, ncol = 3)
vector_pvalue <- matrix(nrow = 11, ncol = 3)
rownames(vector_pvalue) <- SourceRegion
colnames(vector_pvalue) <- c("IT", "PT", "CT")

counter_region <- 0
for(iRegion in SourceRegion) {
  counter_region <- counter_region + 1
  counter_class <- 0
  for(iClass in c("IT", "PT", "CT")) {
    tmpTest <- 
      wilcox.test(x = df$Value[base::intersect(which(df$Group == iClass), 
                                               which(df$Region == iRegion))] - 
                    mean(df$Value[which(df$Group == iClass)]))
    counter_class <- counter_class + 1
    vector_pvalue[counter_region, counter_class] <- tmpTest$p.value
    
    vector_mean[counter_region, counter_class] <- 
      mean(df$Value[base::intersect(which(df$Group == iClass), 
                                    which(df$Region == iRegion))])
  }
}




ColorSourceRegion = c("MOs"="#a6cee3","ACAd"="#1f78b4","ACAv"="#b2df8a",
                      "PL"="#33a02c","ILA"="#fb9a99","FRP"="#e31a1c",
                      "ORBm"="#fdbf6f","ORBvl"="#ff7f00","ORBl"="#cab2d6",
                      "AId"="#6a3d9a","AIv"="#b3b3b3")

# Figures 1E and S1A. correlation of dendritic length among IT, PT, and CT ----

length_of_dendrite_mean <- matrix(nrow = 11, ncol = 3)
rownames(length_of_dendrite_mean) <- SourceRegion
colnames(length_of_dendrite_mean) <- c("IT","PT","CT")

counter_region <- 0
for(iRegion in SourceRegion) {
  counter_region <- counter_region + 1
  counter_class <- 0
  for(iClass in c("IT","PT","CT")) {
    tmp_index <- base::intersect(which(df$Group == iClass), which(df$Region == iRegion))
    counter_class <- counter_class + 1
    length_of_dendrite_mean[counter_region, counter_class] <-
      mean(df$Value[tmp_index])
  }
}


ggplot(data = data.frame(length_of_dendrite_mean/1000, Region = SourceRegion), 
       mapping = aes(x = IT, y = PT)) +
  geom_point(size = 3, aes(color = SourceRegion))+
  geom_smooth(method = "lm") + 
  theme_classic() +
  theme(axis.text.x = element_text(size = 12), 
        axis.text.y = element_text(size = 12), 
        legend.position = "") +
  scale_x_continuous(breaks = get_breaks(n = 8)) + 
  scale_color_manual(values = ColorSourceRegion)+
  #scale_y_continuous(breaks = get_breaks(n = 6), limits = c(0, 5e5)) +
  ggpmisc::stat_fit_glance(method = "lm",
                           geom = "text_npc",
                           aes(label = paste0("P=", signif(..p.value.., digits = 4))),
                           label.x = "left",
                           label.y = "bottom") +
  ggpmisc::stat_poly_eq(aes(label = paste0(..rr.label..)), label.x = "right", label.y = "bottom")





# Figure 1F. dendritic length vs. axonal length ----
# Figure 1G. dendritic length vs. coritical thickness ----

# mean length of dendrites of IT, PT, and CT neurons
length_IT <- feature_all$dendrite_cable.length[which(dendrite_info$Type %in% c("ITi", "ITc"))]
length_PT <- feature_all$dendrite_cable.length[which(dendrite_info$Type %in% c("PT"))]
length_CT <- feature_all$dendrite_cable.length[which(dendrite_info$Type %in% c("CT"))]


feature_axon <- summary(neuronlist_axon)
feature_axon <- feature_axon[Index_apical_tmp,]


# Classification
source("~/Documents/YanLab/Task_Local/LocalMorphology/CodeR/func_calculate_feature_basal.r")

feature_axon_full <- calculate_feature_basal(neuronlist_axon)
feature_axon_full <- feature_axon_full[Index_apical_tmp,]

thickness_soma <- thickness_soma$thickness_soma[Index_apical_tmp]



tmpMatch_axon <- c("ITi"="IT", "ITc"="IT", 
                   "PT"="PT", "CT"="CT")

df <- 
  data.frame(Group = as.factor(tmpMatch_axon[match(dendrite_info$Type[Index_apical_tmp], 
                                                   names(tmpMatch_axon))][which(thickness_soma > 0)]),
             length_dendrite = feature_combine$dendrite_cable.length[which(thickness_soma > 0)],
             length_axon = thickness_soma[which(thickness_soma > 0)])

library(ggExtra)
library(ggpmisc)
library(ggplot2)
library(ggpubr)

p <- 
  ggplot(data = df, 
         mapping = aes(x = length_dendrite, y = length_axon, fill = Group, color = Group)) +
  geom_point()+
  geom_smooth(method = "lm") + 
  theme_bw() +
  theme(axis.text.x = element_text(size = 12), 
        axis.text.y = element_text(size = 12), 
        legend.position = "left") +
  scale_x_continuous(breaks = get_breaks(n = 8)) + 
  #scale_y_continuous(breaks = get_breaks(n = 6), limits = c(0, 5e5)) +
  ggpmisc::stat_fit_glance(method = "lm",
                           geom = "text_npc",
                           aes(label = paste0("P=", signif(..p.value.., digits = 4))),
                           label.x = "left",
                           label.y = "bottom") +
  ggpmisc::stat_poly_eq(aes(label = paste0(..rr.label..)), label.x = "right", label.y = "bottom")

ggExtra::ggMarginal(p = p, groupColour = TRUE, groupFill = TRUE, )



# Figure 1H. correlation with neuron density ----

setwd("/home/admin/Documents/YanLab/Task_Local/LocalMorphology/")

cell_count <-
  read.table(file = "./CodeR/gradient/Data_Sheet_1_A Cell Atlas for the Mouse Brain.CSV", 
             sep = ",", header = T)

cell_density <-
  read.table(file = "./CodeR/gradient/Data_Sheet_2_A Cell Atlas for the Mouse Brain.CSV", 
             sep = ",", header = T)



anno_structure <- 
  read.csv(file = "/home/admin/Documents/YanLab/database_neuron/ABA_annotation/annot.txt", 
           header = FALSE, sep = ":")
colnames(anno_structure) = c("CurrentID", "ParentID", "Color", "Acronym", "Fullname")

library(stringr)
tmp_fullname <- 
  str_remove(string = anno_structure$Fullname[match(SourceRegion, anno_structure$Acronym)], 
             pattern = ",")

tmp_fullname_layer <-
  paste0(rep(tmp_fullname, each = 5), " ",
         rep(c("layer 1", "layer 2/3", "layer 5", "layer 6a", "layer 6b"), times = 11))

tmp_index <- match(tmp_fullname_layer, cell_density$Regions)



tmp_index <- 
  match(str_remove(string = anno_structure$Fullname[match(SourceRegion, 
                                                          anno_structure$Acronym)], 
                   pattern = ","), 
        cell_density$Regions)

# 
# tmp_index <- 
#   match(cell_density$Regions,
#         str_remove(string = anno_structure$Fullname[match(SourceRegion, 
#                                                           anno_structure$Acronym)], 
#                    pattern = ","))
# 


cell_count_PFC <- cell_count[tmp_index, -1]
cell_density_PFC <- cell_density[tmp_index, -1]



matrix_pvalue <- matrix(nrow = 3, ncol = 9)
rownames(matrix_pvalue) <- c("IT", "PT", "CT")
colnames(matrix_pvalue) <- colnames(cell_density_PFC)


df_value_dendrite <- c()
df_value_density <- c()
df_group_dendrite <- c()
df_group_density <- c()
df_group_region <- c()

for(iClass in 1:3) {
  for(iDensity in 1:9) {
    
    tmp_Y <- length_of_dendrite_mean[,iClass]
    tmp_X <- cell_density_PFC[,iDensity]
    
    #tmp_X <- cell_count_PFC[,iDensity]
    
    
    asdf <- cor.test(x = tmp_X, y = tmp_Y)
    matrix_pvalue[iClass, iDensity] <- asdf$p.value
    
    
    df_value_dendrite <- c(df_value_dendrite, tmp_Y)
    df_value_density <- c(df_value_density, tmp_X)
    df_group_dendrite <- 
      c(df_group_dendrite, rep(x = colnames(length_of_dendrite_mean)[iClass], 11))
    df_group_density <- 
      c(df_group_density, rep(x = colnames(cell_density_PFC)[iDensity], 11))
    df_group_region <- c(df_group_region, SourceRegion)
  }
}


df_dendrite_density <- 
  data.frame(Value_dendrite = df_value_dendrite,
             Value_density = df_value_density,
             Group_dendrite = factor(x = df_group_dendrite, levels = c("IT", "PT", "CT")),
             Group_density = df_group_density,
             Group_region = df_group_region)


ggplot(data = df_dendrite_density, 
       mapping = aes(x = Value_dendrite, y = Value_density)) +
  #geom_point(size = 3)+
  geom_point(size = 3, aes(color = Group_region))+
  facet_wrap(~ Group_dendrite + Group_density, scales = "free", nrow = 3, ncol = 9) +
  
  geom_smooth(method = "lm") + 
  theme_classic() +
  theme(axis.text.x = element_text(size = 8), 
        axis.text.y = element_text(size = 8), 
        legend.position = "left") +
  #scale_x_continuous(breaks = get_breaks(n = 8)) + 
  scale_color_manual(values = ColorSourceRegion)+
  #scale_y_continuous(breaks = get_breaks(n = 6), limits = c(0, 5e5)) +
  ggpmisc::stat_fit_glance(method = "lm",
                           geom = "text_npc",
                           aes(label = paste0("P=", signif(..p.value.., digits = 4))),
                           label.x = "left",
                           label.y = "bottom") +
  ggpmisc::stat_poly_eq(aes(label = paste0(..rr.label..)), 
                        label.x = "right", 
                        label.y = "bottom") +
  xlab("Total length of IT dendrites (mm)") +
  ylab("1 / Density of neurons (mm^(-3))")



# 
# 
# plot(y = length_of_dendrite_mean[,1], x = cell_density_PFC$Neurons..mm.3.)
#   
# 
# ggplot(data = data.frame(X = length_of_dendrite_mean[,2]/1000, 
#                          Y =  cell_density_PFC$Neurons..mm.3.,
#                          Region = SourceRegion), 
#        mapping = aes(x = X, y = Y)) +
#   geom_point(size = 3, aes(color = SourceRegion))+
#   geom_smooth(method = "lm") + 
#   theme_classic() +
#   theme(axis.text.x = element_text(size = 12), 
#         axis.text.y = element_text(size = 12), 
#         legend.position = "left") +
#   scale_x_continuous(breaks = get_breaks(n = 8)) + 
#   scale_color_manual(values = ColorSourceRegion)+
#   #scale_y_continuous(breaks = get_breaks(n = 6), limits = c(0, 5e5)) +
#   ggpmisc::stat_fit_glance(method = "lm",
#                            geom = "text_npc",
#                            aes(label = paste0("P=", signif(..p.value.., digits = 4))),
#                            label.x = "left",
#                            label.y = "bottom") +
#   ggpmisc::stat_poly_eq(aes(label = paste0(..rr.label..)), 
#                         label.x = "right", 
#                         label.y = "bottom") +
#   xlab("Total length of IT dendrites (mm)") +
#   ylab("1 / Density of neurons (mm^(-3))")
# 
# 
# 
# 
# 


# Figure 1H. Flatmap of neuronal density and dendritic length ----

colors <- c("darkgreen", "yellow2")

col_fun_density <-
  circlize::colorRamp2(breaks = c(quantile(x = cell_density_PFC$Neurons..mm.3., probs = 0.1), 
                                  #median(cell_density_PFC$Neurons..mm.3.),
                                  quantile(x = cell_density_PFC$Neurons..mm.3., probs = 0.9)),
                       colors = colors)

snp::plot_flatmap_subregion(
  RegionName = SourceRegion,
  Color = substring(text = col_fun_density(x = cell_density_PFC$Neurons..mm.3.), first = 1, last = 7),
  filename_out = "/tmp/flatmap_region.svg")


Heatmap(matrix = cell_density_PFC$Neurons..mm.3., name = "Neuronal density",
        col = col_fun_density)

##
col_fun_dendrite_IT <-
  circlize::colorRamp2(breaks = c(quantile(x = length_of_dendrite_mean[,1], probs = 0.1), 
                                  #quantile(x = length_of_dendrite_mean[,1], probs = 0.5),
                                  quantile(x = length_of_dendrite_mean[,1], probs = 0.9)),
                       colors = colors)

snp::plot_flatmap_subregion(
  RegionName = SourceRegion,
  Color = substring(text = col_fun_dendrite_IT(x = length_of_dendrite_mean[,1]), first = 1, last = 7),
  filename_out = "/tmp/flatmap_region_dendrite_IT.svg")

Heatmap(matrix = length_of_dendrite_mean[,1], name = "IT",
        col = col_fun_dendrite_IT)


#########
col_fun_dendrite_PT <-
  circlize::colorRamp2(breaks = c(quantile(x = length_of_dendrite_mean[,2], probs = 0.1), 
                                  #mean(cell_density_PFC$Neurons..mm.3.),
                                  quantile(x = length_of_dendrite_mean[,2], probs = 0.9)),
                       colors = colors)

snp::plot_flatmap_subregion(
  RegionName = SourceRegion,
  Color = substring(text = col_fun_dendrite_PT(x = length_of_dendrite_mean[,2]), first = 1, last = 7),
  filename_out = "/tmp/flatmap_region_dendrite_PT.svg")


Heatmap(matrix = length_of_dendrite_mean[,2], name = "PT",
        col = col_fun_dendrite_PT)


