# plot dendrite and aoxn together

# figure 3 NPy L2/3




dendrite_info[base::intersect(Index_SP[which(Group == 1)], which(dendrite_info$Type == "ITc")), 1:2]


ttt2 <- intersect(which(dendrite_info$BrainRegion[Index_L23_all[which(group_neuron_L23 == 7)]] == "PL"), 
          which(dendrite_info$Type[Index_L23_all[which(group_neuron_L23 == 7)]] == "ITc"))


ttt3 <- intersect(which(dendrite_info$BrainRegion[Index_L23_all[which(group_neuron_L23 == 9)]] == "PL"), 
                 which(dendrite_info$Type[Index_L23_all[which(group_neuron_L23 == 9)]] == "ITc"))



fullname_neuron_L23 <- 
  paste0(dendrite_info$SampleID[Index_L23_all[ttt2]], "-",
         stringr::str_pad(string = dendrite_info$NeuronID[Index_L23_all[ttt2]], 
                          width = 3, side = "left", pad = "0"))

axonal_projection_L23 <-
  PFC_projection[match(fullname_neuron_L23, fullname_neuron_all), 
                 snp::getStructureFromAcronym(c("r_CP"))]





open3d()
snp::plot_morphology(neuronList = DendriteList_allen[Index_L23_all[which(group_neuron_L23 == 6)][55]], 
                     hemisphere = dendrite_info$Hemisphere[Index_L23_all[which(group_neuron_L23 == 6)][55]],
                     flip = TRUE, soma_size = 20, color = "green")
# 
snp::plot_morphology(neuronList = neuronlist_axon[Index_L23_all[which(group_neuron_L23 == 6)][55]],
                     hemisphere = dendrite_info$Hemisphere[Index_L23_all[which(group_neuron_L23 == 6)][55]],
                     flip = TRUE, soma_size = 20, color = "green")


snp::plot_morphology(neuronList = DendriteList_allen[Index_L23_all[which(group_neuron_L23 == 7)][ttt2[1]]], 
                     hemisphere = dendrite_info$Hemisphere[Index_L23_all[which(group_neuron_L23 == 7)][ttt2[1]]],
                     flip = TRUE, soma_size = 20, color = "cyan")
# 
snp::plot_morphology(neuronList = neuronlist_axon[Index_L23_all[which(group_neuron_L23 == 7)][ttt2[1]]],
                     hemisphere = dendrite_info$Hemisphere[Index_L23_all[which(group_neuron_L23 == 7)][ttt2[1]]],
                     flip = TRUE, soma_size = 20, color = "cyan")



snp::plot_morphology(neuronList = DendriteList_allen[Index_L23_all[which(group_neuron_L23 == 9)][ttt3[22]]], 
                     hemisphere = dendrite_info$Hemisphere[Index_L23_all[which(group_neuron_L23 == 8)][ttt3[22]]],
                     flip = TRUE, soma_size = 20, color = "magenta")
# 
snp::plot_morphology(neuronList = neuronlist_axon[Index_L23_all[which(group_neuron_L23 == 9)][ttt3[22]]],
                     hemisphere = dendrite_info$Hemisphere[Index_L23_all[which(group_neuron_L23 == 9)][ttt3[22]]],
                     flip = TRUE, soma_size = 20, color = "magenta")
# # 



dendrite_info$W[Index_L23_all[which(group_neuron_L23 == 8)][361]]








plot3d(DendriteList_allen[Index_L23_all[which(group_neuron_L23 == 6)]], 
       WithNodes = F, color = "red", soma = 20)
plot3d(neuronlist_axon[Index_L23_all[which(group_neuron_L23 == 6)]], 
       WithNodes = F, color = "blue")



mesh_TH <- readOBJ("/home/admin/Documents/YanLab/database_neuron/ABA_mesh/549_TH.obj")

mesh_Ipsi_BLA <- readOBJ("/home/admin/Documents/YanLab/database_neuron/ABA_mesh_left_hemisphere/295_BLA.obj")
mesh_Both_CP <- readOBJ("/home/admin/Documents/YanLab/database_neuron/ABA_mesh/672_CP.obj")



shade3d(mesh_root, color = "white", alpha = 0.1)
#wire3d(mesh_STRd, color = "white", alpha = 0.1)

#wire3d(mesh_TH, color = "white", alpha = 0.1)

shade3d(mesh_Ipsi_BLA, color = "white", alpha = 0.2)
shade3d(mesh_Both_CP, color = "white", alpha = 0.2)

view3d(fov = 0, userMatrix = userMatrix_DV)



userMatrix_DV = matrix(data = c(0,0,1,0,
                                -1,0,0,0,
                                0,-1,0,0,
                                0,0,0,1), nrow = 4, ncol = 4, byrow = TRUE)

userMatrix_LM = matrix(data = c(1,0,0,0, 
                                0,-1,0,0, 
                                0,0,-1,0, 
                                0,0,0,1), 
                       nrow = 4, ncol = 4, byrow = TRUE)

userMatrix_AP = matrix(data = c(0,0,-1,0, 
                                0,-1,0,0, 
                                -1,0,0,0, 
                                0,0,0,1), 
                       nrow = 4, ncol = 4, byrow = TRUE)