# inter-column ipsi-lateral 
# figure 7


# mean value across multiple PFC units ----
connection_type_mean_unit_ipsi <- matrix(nrow = 5, ncol = 5, data = 0)

counter_valid <- 0
# units in the red module 
for(iUnit in order_unit[17]) { 
  for(jUnit in order_unit[1:21]) {
    if(iUnit == jUnit) {
      next
    }
    
    tmp_connection <-
      connection_type_ipsi[which(label_column_all %in% iUnit), 
                           which(label_column_all %in% jUnit)]
    
    if(length(which(is.na(tmp_connection) == TRUE)) == 0) {
      counter_valid <- counter_valid + 1
      connection_type_mean_unit_ipsi <- connection_type_mean_unit_ipsi + tmp_connection
    }
  }
}

connection_type_mean_unit_ipsi <- connection_type_mean_unit_ipsi / counter_valid

rownames(connection_type_mean_unit_ipsi) <- label_type
colnames(connection_type_mean_unit_ipsi) <- label_type

Heatmap(connection_type_mean_unit_ipsi, 
        row_names_side = "left", column_names_side = "top",
        cluster_rows = F, cluster_columns = F)


test <- connection_type_ipsi[which(label_column_all %in% 22), 
                             which(label_column_all %in% 56)]

rownames(test) <- label_type
colnames(test) <- label_type

Heatmap(test, name = "22->56",
        row_names_side = "left", column_names_side = "top",
        cluster_rows = F, cluster_columns = F)




test <- connection_type_ipsi[which(label_column_all %in% 56), 
                             which(label_column_all %in% 22)]

rownames(test) <- label_type
colnames(test) <- label_type

Heatmap(test, name = "56->22",
        row_names_side = "left", column_names_side = "top",
        cluster_rows = F, cluster_columns = F)




#####

connection_units_ipsi <- matrix(nrow = 25, ncol = 20)

counter_unit <- 0
# units in the red module 
for(iUnit in order_unit[17]) { 
  for(jUnit in order_unit[1:21]) {
    if(iUnit == jUnit) {
      next
    }
    
    tmp_connection <-
      connection_type_ipsi[which(label_column_all %in% iUnit), 
                           which(label_column_all %in% jUnit)]
    
      counter_unit <- counter_unit + 1
      connection_units_ipsi[,counter_unit] <- as.vector(t(tmp_connection))
  }
}




tmpMatch_connection <- c("L23 IT->L23 IT" = 1,
                         "L5 IT->L5 IT" = 2, 
                         "L5 PT->L5 PT" = 3,
                         "L6 IT->L6 IT" = 4,
                         "L6 CT->L6 CT" = 5,
                         
                         "L23 IT->L5 IT" = 6, "L5 IT->L23 IT" = 6,
                         "L23 IT->L5 PT" = 7, "L5 PT->L23 IT" = 7,
                         "L23 IT->L6 IT" = 8, "L6 IT->L23 IT" = 8,
                         "L23 IT->L6 CT" = 9, "L6 CT->L23 IT" = 9,
                         
                         "L5 IT->L5 PT" = 10, "L5 PT->L5 IT" = 10,
                         "L5 IT->L6 IT" = 11, "L6 IT->L5 IT" = 11,
                         "L5 IT->L6 CT" = 12, "L6 CT->L5 IT" = 12,
                         
                         "L5 PT->L6 IT" = 13, "L6 IT->L5 PT" = 13,
                         "L5 PT->L6 CT" = 14, "L6 CT->L5 PT" = 14,
                         "L6 IT->L6 CT" = 15, "L6 CT->L6 IT" = 15)



group_connection_direct <- c()  
Value <- c()

counter_connection <- 0
for(iLabelAxon in label_type) {
  for(iLabelDendrite in label_type) {
    group_connection_direct <- c(group_connection_direct, 
                                 rep(paste0(iLabelAxon, "->", iLabelDendrite), 20))
    
    counter_connection <- counter_connection + 1
    Value <- c(Value, connection_units_ipsi[counter_connection,])
  }
}


group_connection_undirect <- 
  tmpMatch_connection[match(group_connection_direct, names(tmpMatch_connection))]





ggplot(data = data.frame(Group = factor(x = group_connection_direct, 
                                        levels = names(tmpMatch_connection)), 
                         Value = Value, 
                         Class = factor(x = group_connection_undirect, levels = 1:15)), 
       mapping = aes(x = Group, y = Value)) +
  #facet_wrap(facets = "Class") +
  geom_boxplot() +
  #scale_y_continuous(limits = c(0,30)) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 90)) +
  stat_compare_means(ref.group = ".all.", method.args = list(alternative = "greater"),
                     aes(label = ..p.signif..)) +
  geom_hline(yintercept = mean(Value))



