# contra-lateral projection
# figure 7 

# 
# mean_connection <- 
#   connection_type_contra[which(label_column_all %in% 7), 
#                          which(label_column_all %in% 7)]
# 
# rownames(mean_connection) <- label_type
# colnames(mean_connection) <- label_type
# 
# Heatmap(mean_connection, 
#         row_names_side = "left", column_names_side = "top",
#         cluster_rows = F, cluster_columns = F)
# 
# 
# 
# PFC_unit <- 7
# 
# 
# data_raw <- list()
# counter <- 0
# for(iLabelAxon in paste0(PFC_unit, "-", label_type)) {
#   for(iLabelDendrite in paste0(PFC_unit, "-", label_type)) {
#     
#     tmp_index_axon <- which(label_column_type == iLabelAxon)
#     tmp_index_dendrite <- which(label_column_type == iLabelDendrite)
#     
#     tmp_index <- (tmp_index_axon - 1) * 300 + tmp_index_dendrite
#     
#     counter <- counter + 1
#     data_raw[[counter]] <- connection_raw_contra[[tmp_index]]
#   }
# }
# 
# 
# L23_IT_total <- mean(unlist(data_raw[1:5]))
# wilcox.test(as.vector(data_raw[[3]]), L23_IT_total)
# 
# 
# L5_IT_total <- mean(unlist(data_raw[6:10]))
# wilcox.test(as.vector(data_raw[[8]]), L5_IT_total)
# 
# 


# mean value across multiple PFC units ----
connection_type_mean_unit_contra <- matrix(nrow = 5, ncol = 5, data = 0)
connection_type_median_unit_contra <- matrix(nrow = 21, ncol = 25, data = 0)


counter_valid <- 0
for(iUnit in PFC_unit_valid) {
  
  tmp_connection <-
    connection_type_contra[which(label_column_all %in% iUnit), 
                         which(label_column_all %in% iUnit)]
  
  if(length(which(is.na(tmp_connection) == TRUE)) == 0) {
    counter_valid <- counter_valid + 1
    connection_type_mean_unit_contra <- connection_type_mean_unit_contra + tmp_connection
    connection_type_median_unit_contra[counter_valid,] <- as.vector(t(tmp_connection))
  }
}

connection_type_mean_unit_contra <- connection_type_mean_unit_contra / 21

connection_type_median_unit_contra_single <- 
  t(matrix(colMedians(connection_type_median_unit_contra), nrow=5, ncol = 5))


Heatmap(connection_type_mean_unit_contra, 
        row_names_side = "left", column_names_side = "top",
        cluster_rows = F, cluster_columns = F)


Heatmap(connection_type_median_unit_contra_single, 
        row_names_side = "left", column_names_side = "top",
        cluster_rows = F, cluster_columns = F)





#


connection_units_contra <- matrix(nrow = 25, ncol = 21)

counter_unit <- 0
for(iUnit in PFC_unit_valid) {
  
  tmp_connection <-
    connection_type_contra[which(label_column_all %in% iUnit), 
                           which(label_column_all %in% iUnit)]
  
  counter_unit <- counter_unit + 1
  
  connection_units_contra[,counter_unit] <- as.vector(t(tmp_connection))
}



tmpMatch_connection <- c("L23 IT->L23 IT" = 1,
                         "L5 IT->L5 IT" = 2, 
                         "L5 PT->L5 PT" = 3,
                         "L6 IT->L6 IT" = 4,
                         "L6 CT->L6 CT" = 5,
                         
                         "L23 IT->L5 IT" = 6, "L5 IT->L23 IT" = 6,
                         "L23 IT->L5 PT" = 7, "L5 PT->L23 IT" = 7,
                         "L23 IT->L6 IT" = 8, "L6 IT->L23 IT" = 8,
                         "L23 IT->L6 CT" = 9, "L6 CT->L23 IT" = 9,
                         
                         "L5 IT->L5 PT" = 10, "L5 PT->L5 IT" = 10,
                         "L5 IT->L6 IT" = 11, "L6 IT->L5 IT" = 11,
                         "L5 IT->L6 CT" = 12, "L6 CT->L5 IT" = 12,
                         
                         "L5 PT->L6 IT" = 13, "L6 IT->L5 PT" = 13,
                         "L5 PT->L6 CT" = 14, "L6 CT->L5 PT" = 14,
                         "L6 IT->L6 CT" = 15, "L6 CT->L6 IT" = 15)



group_connection_direct <- c()  
Value <- c()

counter_connection <- 0
for(iLabelAxon in label_type) {
  for(iLabelDendrite in label_type) {
    group_connection_direct <- c(group_connection_direct, 
                                 rep(paste0(iLabelAxon, "->", iLabelDendrite), 21))
    
    counter_connection <- counter_connection + 1
    Value <- c(Value, connection_units_contra[counter_connection,])
  }
}


group_connection_undirect <- 
  tmpMatch_connection[match(group_connection_direct, names(tmpMatch_connection))]




index_valid <- which(group_connection_direct %in% 
                       c("L23 IT->L23 IT", "L23 IT->L5 IT", "L23 IT->L5 PT", "L23 IT->L6 IT", "L23 IT->L6 CT",
                         "L5 IT->L23 IT", "L5 IT->L5 IT", "L5 IT->L5 PT", "L5 IT->L6 IT", "L5 IT->L6 CT",
                         "L6 IT->L23 IT", "L6 IT->L5 IT", "L6 IT->L5 PT", "L6 IT->L6 IT", "L6 IT->L6 CT"))

ggplot(data = data.frame(Group = factor(x = group_connection_direct[index_valid], 
                                        levels =  c("L23 IT->L23 IT", "L23 IT->L5 IT", "L23 IT->L5 PT", "L23 IT->L6 IT", "L23 IT->L6 CT",
                                                    "L5 IT->L23 IT", "L5 IT->L5 IT", "L5 IT->L5 PT", "L5 IT->L6 IT", "L5 IT->L6 CT",
                                                    "L6 IT->L23 IT", "L6 IT->L5 IT", "L6 IT->L5 PT", "L6 IT->L6 IT", "L6 IT->L6 CT")), 
                         Value = Value[index_valid]), 
       mapping = aes(x = Group, y = Value)) +
  #facet_wrap(facets = "Class") +
  geom_boxplot() +
  #scale_y_continuous(limits = c(0,30)) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 90)) +
  stat_compare_means(ref.group = ".all.", method.args = list(alternative = "greater")) +
  geom_hline(yintercept = mean(Value[index_valid]))



# heatmap ----
# figure S7B
colnames(connection_units_contra) <- PFC_unit_valid
Heatmap(matrix = as.matrix(connection_units_contra), 
        cluster_rows = F, 
        cluster_columns = F)

## visualizatio graph ----

connection_type_ipsi_and_contra <- matrix(nrow = 10, ncol = 10, data = 0)
connection_type_ipsi_and_contra[1:5,1:5] <- connection_type_mean_unit
connection_type_ipsi_and_contra[6:10,6:10] <- connection_type_mean_unit
connection_type_ipsi_and_contra[1:5,6:10] <- connection_type_mean_unit_contra
connection_type_ipsi_and_contra[6:10,1:5] <- connection_type_mean_unit_contra
# 
# connection_type_ipsi_and_contra[6,2] <- 0
# connection_type_ipsi_and_contra[6,4] <- 0
# connection_type_ipsi_and_contra[6,5] <- 0
# connection_type_ipsi_and_contra[7,4] <- 0
# connection_type_ipsi_and_contra[7,5] <- 0
# connection_type_ipsi_and_contra[9,1:5] <- 0

index_valid <- c(1,2,3,4,5,6,7,9)

index_valid <- 1:10


asdf <- connection_type_ipsi_and_contra[index_valid, index_valid]
rownames(asdf) <- c(paste0("Ipsi: ", group_layer_axon_valid), 
                    paste0("Contra: ", group_layer_axon_valid))[index_valid]
colnames(asdf) <- c(paste0("Ipsi: ", group_layer_axon_valid), 
                    paste0("Contra: ", group_layer_axon_valid))[index_valid]

coord_PFC_ROIs_real <- matrix(data = 0, nrow = 10, ncol = 2)
coord_PFC_ROIs_real[1,] <- c(2, 50)
coord_PFC_ROIs_real[2,] <- c(2, 40)
coord_PFC_ROIs_real[3,] <- c(2, 30)
coord_PFC_ROIs_real[4,] <- c(2, 20)
coord_PFC_ROIs_real[5,] <- c(2, 10)

coord_PFC_ROIs_real[6,] <- c(0, 50)
coord_PFC_ROIs_real[7,] <- c(0, 40)
coord_PFC_ROIs_real[8,] <- c(0, 30)
coord_PFC_ROIs_real[9,] <- c(0, 20)
coord_PFC_ROIs_real[10,] <- c(0, 10)


Graph_PFC = graph_from_adjacency_matrix(adjmatrix = as.matrix(asdf),
                                        mode = "directed", 
                                        weighted = TRUE,
                                        add.colnames = TRUE)
V(Graph_PFC)$name <- c(paste0("Ipsi: ", group_layer_axon_valid), 
                       paste0("Contra: ", group_layer_axon_valid))[index_valid]

edge.start <- ends(Graph_PFC, es = E(Graph_PFC), names = FALSE)[,1]


plot(Graph_PFC, 
     #vertex.color = colorset[label_module],
     #vertex.size = 10,
     #vertex.label.family = "Arial",
     #vertex.label.font = 1,
     
     
     #edge.color = edge.col,
     edge.width = E(Graph_PFC)$weight * 2,#/1000,
     edge.curved = as.vector(t(para_curve)),
     #edge.arrow.size = 0.5,
     #edge.arrow.width = 0.5,
     layout = coord_PFC_ROIs_real[index_valid,]
)

library(qgraph)

# parameter: curve
para_curve <- matrix(nrow = 10, ncol = 10)
para_curve[1:5, 1:5] <- 0
para_curve[1:5, 6:10] <- 0
para_curve[6:10, 1:5] <- 0
para_curve[6:10, 6:10] <- 0


eqarrowPlot(graph = Graph_PFC,
            #vertex.color = colorset[label_module],
            #vertex.size = 10,
            #vertex.label.family = "Arial",
            #vertex.label.font = 1,
            
            
            #edge.color = edge.col,
            edge.width = E(Graph_PFC)$weight * 2,
            edge.curved = as.vector(t(para_curve)),
            edge.arrow.size = E(Graph_PFC)$weight / 3,
            edge.arrow.width = E(Graph_PFC)$weight / 3,
            layout = coord_PFC_ROIs_real[index_valid,]
)
