# intra-column connectivity
# figure 7


PFC_unit_valid <- column_valid


connection_L23_IT_to_L5_IT <- matrix(nrow = 21, ncol = 1)
connection_L23_IT_to_L5_PT <- matrix(nrow = 21, ncol = 1)
connection_L5_IT_to_L23_IT <- matrix(nrow = 21, ncol = 1)
connection_L5_PT_to_L23_IT <- matrix(nrow = 21, ncol = 1)

connection_type_mean_unit <- matrix(nrow = 5, ncol = 5, data = 0)

counter <- 0
counter_valid <- 0
for(iUnit in PFC_unit_valid) {
  
  tmp_connection <-
    connection_type_ipsi[which(label_column_all %in% iUnit), 
                         which(label_column_all %in% iUnit)]
  
  print(tmp_connection)
  
  
  tmp_connection_L23_IT_to_L5_IT <- tmp_connection[1,2]
  tmp_connection_L23_IT_to_L5_PT <- tmp_connection[1,3]
  tmp_connection_L5_IT_to_L23_IT <- tmp_connection[2,1]
  tmp_connection_L5_PT_to_L23_IT <- tmp_connection[3,1]
  
  counter <- counter + 1
  connection_L23_IT_to_L5_IT[counter, 1] <- tmp_connection_L23_IT_to_L5_IT
  connection_L23_IT_to_L5_PT[counter, 1] <- tmp_connection_L23_IT_to_L5_PT
  connection_L5_IT_to_L23_IT[counter, 1] <- tmp_connection_L5_IT_to_L23_IT
  connection_L5_PT_to_L23_IT[counter, 1] <- tmp_connection_L5_PT_to_L23_IT
  
  if(length(which(is.na(tmp_connection) == TRUE)) == 0) {
    counter_valid <- counter_valid + 1
    connection_type_mean_unit <- connection_type_mean_unit + tmp_connection
  }
  
  
}

connection_type_mean_unit <- connection_type_mean_unit / 21


Value <- c(connection_L23_IT_to_L5_IT, 
           connection_L23_IT_to_L5_PT,
           connection_L5_IT_to_L23_IT,
           connection_L5_PT_to_L23_IT)

Group <- c(rep("L23_IT_to_L5_IT", length(connection_L23_IT_to_L5_IT)),
           rep("L23_IT_to_L5_PT", length(connection_L23_IT_to_L5_PT)),
           rep("L5_IT_to_L23_IT", length(connection_L5_IT_to_L23_IT)),
           rep("L5_PT_to_L23_IT", length(connection_L5_PT_to_L23_IT)))


library(ggpubr)
# 
# ggplot(data = data.frame(Value = Value, Group = Group), 
#        mapping = aes(x = Group, y = Value)) +
#   geom_boxplot() +
#   stat_compare_means(comparisons = list(c("L23_IT_to_L5_IT","L23_IT_to_L5_PT"), 
#                                         c("", ""))



Heatmap(connection_type_mean_unit, 
        cluster_rows = F, cluster_columns = F)
                     

                     
# edge polarity ----

edge_polarity_units <- matrix(nrow = 10, ncol = 21)
connection_units <- matrix(nrow = 25, ncol = 21)

counter_unit <- 0
for(iUnit in PFC_unit_valid) {
  
  tmp_connection <-
    connection_type_ipsi[which(label_column_all %in% iUnit), 
                         which(label_column_all %in% iUnit)]
  
  
  edge_polarity <- matrix(nrow = 10, ncol = 1)
  counter_edge <- 0
  for(iAxon in 1:4) {
    for(iDendrite in (iAxon+1):5) {
      counter_edge <- counter_edge + 1
      edge_polarity[counter_edge, 1] <- 
        (tmp_connection[iAxon, iDendrite] - tmp_connection[iDendrite, iAxon]) / 
        (tmp_connection[iAxon, iDendrite] + tmp_connection[iDendrite, iAxon])
    }
  }
  
  counter_unit <- counter_unit + 1
  edge_polarity_units[,counter_unit] <- edge_polarity
  
  connection_units[,counter_unit] <- as.vector(t(tmp_connection))
}

tmpMatch_connection <- c("L23 IT->L23 IT" = 1,
                         "L5 IT->L5 IT" = 2, 
                         "L5 PT->L5 PT" = 3,
                         "L6 IT->L6 IT" = 4,
                         "L6 CT->L6 CT" = 5,
                         
                         "L23 IT->L5 IT" = 6, "L5 IT->L23 IT" = 6,
                         "L23 IT->L5 PT" = 7, "L5 PT->L23 IT" = 7,
                         "L23 IT->L6 IT" = 8, "L6 IT->L23 IT" = 8,
                         "L23 IT->L6 CT" = 9, "L6 CT->L23 IT" = 9,
                         
                         "L5 IT->L5 PT" = 10, "L5 PT->L5 IT" = 10,
                         "L5 IT->L6 IT" = 11, "L6 IT->L5 IT" = 11,
                         "L5 IT->L6 CT" = 12, "L6 CT->L5 IT" = 12,
                         
                         "L5 PT->L6 IT" = 13, "L6 IT->L5 PT" = 13,
                         "L5 PT->L6 CT" = 14, "L6 CT->L5 PT" = 14,
                         "L6 IT->L6 CT" = 15, "L6 CT->L6 IT" = 15)



group_connection_direct <- c()  
Value <- c()

counter_connection <- 0
for(iLabelAxon in label_type) {
  for(iLabelDendrite in label_type) {
    group_connection_direct <- c(group_connection_direct, 
                                 rep(paste0(iLabelAxon, "->", iLabelDendrite), 21))
    
    counter_connection <- counter_connection + 1
    Value <- c(Value, connection_units[counter_connection,])
  }
}

group_connection_undirect <- 
  tmpMatch_connection[match(group_connection_direct, names(tmpMatch_connection))]



ggplot(data = data.frame(Group = factor(x = group_connection_direct, 
                                        levels = names(tmpMatch_connection)), 
                         Value = Value, 
                         Class = factor(x = group_connection_undirect, levels = 1:15)), 
       mapping = aes(x = Group, y = Value)) +
  #facet_wrap(facets = "Class") +
  geom_boxplot() +
  scale_y_continuous(limits = c(0,30)) +
  theme_classic() +
  theme(axis.text.x = element_text(angle = 90)) +
  stat_compare_means(comparisons = list(c("L23 IT->L5 IT", "L5 IT->L23 IT"),
                                        c("L23 IT->L5 PT", "L5 PT->L23 IT"),
                                        c("L23 IT->L6 IT", "L6 IT->L23 IT"),
                                        c("L23 IT->L6 CT", "L6 CT->L23 IT"),
                                        c("L5 IT->L5 PT", "L5 PT->L5 IT"),
                                        c("L5 IT->L6 IT", "L6 IT->L5 IT"),
                                        c("L5 IT->L6 CT", "L6 CT->L5 IT"),
                                        c("L5 PT->L6 IT", "L6 IT->L5 PT"),
                                        c("L5 PT->L6 CT", "L6 CT->L5 PT"),
                                        c("L6 IT->L6 CT", "L6 CT->L6 IT"))) 


# heatmap ----
# figure S7A
colnames(connection_units) <- PFC_unit_valid
Heatmap(matrix = as.matrix(connection_units), 
        cluster_rows = F, 
        cluster_columns = F)


## visualization: graph ----
asdf <- connection_type_mean_unit
rownames(asdf) <- group_layer_axon_valid
colnames(asdf) <- group_layer_axon_valid

coord_PFC_ROIs_real <- matrix(data = 0, nrow = 5, ncol = 2)
coord_PFC_ROIs_real[1,] <- c(0, 30)
coord_PFC_ROIs_real[2,] <- c(0, 25)
coord_PFC_ROIs_real[3,] <- c(0, 20)
coord_PFC_ROIs_real[4,] <- c(0, 15)
coord_PFC_ROIs_real[5,] <- c(0, 10)


Graph_PFC = graph_from_adjacency_matrix(adjmatrix = as.matrix(asdf),
                                        mode = "directed", 
                                        weighted = TRUE,
                                        add.colnames = TRUE)
V(Graph_PFC)$name <- group_layer_axon_valid
V(Graph_PFC)$color <- colorset[label_module]

edge.start <- ends(Graph_PFC, es = E(Graph_PFC), names = FALSE)[,1]
edge.col <- V(Graph_PFC)$color[edge.start]


plot(Graph_PFC, 
     #vertex.color = colorset[label_module],
     #vertex.size = 10,
     #vertex.label.family = "Arial",
     #vertex.label.font = 1,
     
     
     #edge.color = edge.col,
     edge.width = E(Graph_PFC)$weight * 1,#/1000,
     edge.curved = 1,#curve_multiple(Graph_PFC, start = 90),
     #  edge.arrow.size = 0.3,
     layout = coord_PFC_ROIs_real
)




eqarrowPlot(graph = Graph_PFC,
            #vertex.color = colorset[label_module],
            #vertex.size = 10,
            #vertex.label.family = "Arial",
            #vertex.label.font = 1,
            
            
            #edge.color = edge.col,
            edge.width = E(Graph_PFC)$weight * 2,
            edge.curved = rep(1, ecount(Graph_PFC)),
            edge.arrow.size = E(Graph_PFC)$weight / 3,
            edge.arrow.width = E(Graph_PFC)$weight / 3,
            layout = coord_PFC_ROIs_real
)




library(qgraph)

qgraph(asdf, 
       asize = asdf,
       #edge.width = asdf,
       curve = 3,
       directed = TRUE,
       tuning = 0, # ?
       layout = coord_PFC_ROIs_real,
       width = 5)


graph <- Graph_PFC
layout <- coord_PFC_ROIs_real

eqarrowPlot <- function(graph, 
                        layout, 
                        edge.lty=rep(1, ecount(graph)),
                        edge.arrow.size=rep(1, ecount(graph)),
                        vertex.shape="circle",
                        edge.curved=autocurve.edges(graph),
                        edge.width,...) {
  plot(graph, edge.lty=0, edge.arrow.size=0, layout=layout,
       vertex.shape="none")
  for (e in seq_len(ecount(graph))) {
    graph2 <- delete.edges(graph, E(graph)[(1:ecount(graph))[-e]])
    #    plot(graph2, edge.lty=edge.lty[e], edge.arrow.size=edge.arrow.size[e],
    #         edge.curved=edge.curved[e], layout=layout, vertex.shape="none",
    #         vertex.label=NA, add=TRUE, ...)
    plot(graph2, edge.lty=edge.lty[e], edge.arrow.size=edge.arrow.size[e],
         edge.curved=edge.curved[e], layout=layout, vertex.shape="none",
         vertex.label=NA, add=TRUE, edge.width = edge.width[e], ...)
  }
  plot(graph, edge.lty=0, edge.arrow.size=0, layout=layout,
       vertex.shape=vertex.shape, add=TRUE, edge.weights = weights)
  invisible(NULL)
}



# 
# 
# 
# Heatmap(connection_type_ipsi[which(label_column_all %in% 7), 
#                              which(label_column_all %in% 7)], 
#         cluster_rows = F, cluster_columns = F)
# 
# 
# Heatmap(connection_type_ipsi[which(label_column_all %in% 14), 
#                              which(label_column_all %in% 14)], 
#         cluster_rows = F, cluster_columns = F)
# 
# 
# PFC_unit <- 7
# 
# 
# data_raw <- list()
# counter <- 0
# for(iLabelAxon in paste0(PFC_unit, "-", label_type)) {
#   for(iLabelDendrite in paste0(PFC_unit, "-", label_type)) {
#     
#     tmp_index_axon <- which(label_column_type == iLabelAxon)
#     tmp_index_dendrite <- which(label_column_type == iLabelDendrite)
#     
#     tmp_index <- (tmp_index_axon - 1) * 300 + tmp_index_dendrite
#     
#     counter <- counter + 1
#     data_raw[[counter]] <- connection_raw_ipsi[[tmp_index]]
#   }
# }
# 
# 
# 
# 
# Value <- c(data_raw[[1]], data_raw[[2]], data_raw[[3]], data_raw[[4]], data_raw[[5]])
# Group <- c(rep("L23 IT->L23 IT", length(data_raw[[1]])), 
#            rep("L23 IT->L5 IT", length(data_raw[[2]])), 
#            rep("L23 IT->L5 PT", length(data_raw[[3]])), 
#            rep("L23 IT->L6 IT", length(data_raw[[4]])), 
#            rep("L23 IT->L6 CT", length(data_raw[[5]])))
# 
# 
# wilcox.test(as.vector(data_raw[[1]]), mu = mean(Value), alternative = "less")
# 
# 
# 
# 
# 
# df<-data.frame(Group = Group, Value = Value)
# 
# 
# res.aov <- aov(formula = Value ~ Group, df)
# TukeyHSD(x = res.aov)
# 

